@component('home.layouts.component', ['title' => 'تایید حساب‌کاربری'])

    @slot('style')

    @endslot

    @slot('content')
        <div class="auth-background">
            <div class="container h-100">
                <div class="row align-items-center h-100">
                    <div class="col-lg-6 col-md-8 mx-auto">
                        <div class="card">
                            <div class="card-header"><strong>{{ __('لطفا آدرس ایمیل خود را تأیید کنید') }}</strong>
                            </div>

                            <div class="card-body mx-lg-5 px-lg-3 text-justify">
                                @if (session('resent'))
                                    <div class="alert alert-success" role="alert">
                                        {{ __('لینک فعال‌سازی جدیدی برای ایمیل شما ارسال گردید.') }}
                                    </div>
                                @endif

                                {{ __('لطفا برای ادامه فعالیت در سایت، لینک فعال‌سازی ارسال شده را تایید نمایید.') }}
                                {{ __('اگر ایمیل را دریافت نکرده‌اید،') }}
                                <form class="d-inline" method="POST" action="{{ route('verification.resend') }}">
                                    @csrf
                                    <button type="submit"
                                            class="btn btn-link p-0 m-0 align-baseline">{{ __('بر روی این لینک کلیک نمایید.') }}</button>
                                </form>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    @endslot

    @slot('script')

    @endslot

@endcomponent
