@component('home.layouts.component', ['title' => 'تغییر رمز عبور'])

    @slot('style')

    @endslot

    @slot('content')
        <div class="auth-background">
            <div class="container h-100">
                <div class="row align-items-center h-100">
                    <div class="col-lg-6 col-md-8 mx-auto">
                        <div class="card">
                            <div class="card-header"><strong>{{ __('تغییر رمز عبور') }}</strong></div>

                            <div class="card-body mx-lg-5 px-lg-3">
                                @if (session('status'))
                                    <div class="alert alert-success" role="alert">
                                        {{ session('status') }}
                                    </div>
                                @endif

                                <form method="POST" action="{{ route('password.email') }}">
                                    @csrf

                                    <div class="form-group">
                                        <label for="email">{{ __('ایمیل') }}</label>
                                        <input id="email" type="email"
                                               class="form-control @error('email') is-invalid @enderror" name="email"
                                               value="{{ old('email') }}" required autocomplete="email" autofocus>

                                        @error('email')
                                        <span class="invalid-feedback" role="alert">
                                            <strong>{{ $message }}</strong>
                                        </span>
                                        @enderror
                                    </div>

                                    <div class="form-group mb-0">
                                        <div class="">
                                            <button type="submit" class="btn btn-primary">
                                                {{ __('ارسال') }}
                                            </button>
                                        </div>
                                    </div>
                                </form>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    @endslot

    @slot('script')

    @endslot

@endcomponent
